"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_dom_1 = tslib_1.__importDefault(require("react-dom"));
var BoundsUpdateDetector = /** @class */ (function (_super) {
    tslib_1.__extends(BoundsUpdateDetector, _super);
    function BoundsUpdateDetector() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BoundsUpdateDetector.prototype.componentDidMount = function () {
        this.size = this.getSize();
    };
    BoundsUpdateDetector.prototype.getSize = function () {
        var element = react_dom_1.default.findDOMNode(this);
        return {
            width: element.offsetWidth,
            height: element.offsetHeight,
        };
    };
    BoundsUpdateDetector.prototype.componentDidUpdate = function (prevProps, prevState) {
        var size = this.getSize();
        var _a = this.size, width = _a.width, height = _a.height;
        if (height !== size.height || width !== size.width) {
            this.size = size;
            this.props.onUpdate && this.props.onUpdate(size);
        }
    };
    BoundsUpdateDetector.prototype.render = function () {
        return this.props.children;
    };
    return BoundsUpdateDetector;
}(react_1.default.Component));
exports.BoundsUpdateDetector = BoundsUpdateDetector;
//# sourceMappingURL=BoundsUpdateDetector.js.map