"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_2 = require("react");
var pure_1 = require("../../utils/pure");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var withTheme_1 = require("../../utils/withTheme");
exports.CHECKBOX = Symbol('Checkbox');
var RawCheckbox = /** @class */ (function (_super) {
    tslib_1.__extends(RawCheckbox, _super);
    function RawCheckbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = function (element) {
            _this.props.onValueChange(element.target.checked);
        };
        return _this;
    }
    RawCheckbox.prototype.render = function () {
        var _a, _b;
        var _c = this.props, id = _c.id, checkMark = _c.checkMark, isDisabled = _c.isDisabled, value = _c.value, theme = _c.theme;
        var iconClassName = classnames_1.default(theme.icon, (_a = {},
            _a[theme.icon_isChecked] = value,
            _a[theme.icon_isDisabled] = isDisabled,
            _a));
        var viewClassName = classnames_1.default(theme.view, (_b = {},
            _b[theme.view_isDisabled] = isDisabled,
            _b));
        return (react_1.default.createElement("span", { className: theme.container },
            react_1.default.createElement("input", { type: "checkbox", id: id, checked: value || false, disabled: isDisabled, onChange: this.handleChange, className: theme.input }),
            react_1.default.createElement("span", { className: viewClassName },
                react_1.default.createElement("span", { className: iconClassName }, checkMark))));
    };
    RawCheckbox = tslib_1.__decorate([
        pure_1.PURE
    ], RawCheckbox);
    return RawCheckbox;
}(react_2.Component));
exports.Checkbox = withTheme_1.withTheme(exports.CHECKBOX)(RawCheckbox);
//# sourceMappingURL=Checkbox.js.map