"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var pure_1 = require("../../utils/pure");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var Demo_1 = tslib_1.__importDefault(require("../demo/Demo"));
var checkbox_tick_icon_1 = require("../../icons/checkbox-tick-icon");
var Checkbox_1 = require("./Checkbox");
var react_2 = require("@storybook/react");
var addon_knobs_1 = require("@storybook/addon-knobs");
var Checkbox_page_styl_1 = tslib_1.__importDefault(require("./Checkbox.page.styl"));
var darkDemoTheme = {
    container: Checkbox_page_styl_1.default.container,
    view: Checkbox_page_styl_1.default.view,
    icon: Checkbox_page_styl_1.default.icon,
    icon_isDisabled: Checkbox_page_styl_1.default.icon_isDisabled,
};
exports.CHECKBOX = 'Checkbox';
var CheckboxPage = /** @class */ (function (_super) {
    tslib_1.__extends(CheckboxPage, _super);
    function CheckboxPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isChecked: true,
        };
        _this.onChangeHandler = function (value) {
            _this.setState({
                isChecked: Boolean(value),
            });
        };
        return _this;
    }
    CheckboxPage.prototype.render = function () {
        var _a;
        var labelClassName = classnames_1.default(Checkbox_page_styl_1.default.label, (_a = {},
            _a[Checkbox_page_styl_1.default.label_isDisabled] = this.props.isDisabled,
            _a));
        return (react_1.default.createElement(Demo_1.default, null,
            react_1.default.createElement("div", { className: Checkbox_page_styl_1.default.container },
                react_1.default.createElement("label", { htmlFor: "check1", className: labelClassName },
                    react_1.default.createElement(Checkbox_1.Checkbox, { theme: darkDemoTheme, checkMark: react_1.default.createElement(checkbox_tick_icon_1.CheckboxTickIcon, null), value: this.state.isChecked, onValueChange: this.onChangeHandler, isDisabled: this.props.isDisabled, id: "check1" }),
                    "I'am controlled checkbox"))));
    };
    CheckboxPage = tslib_1.__decorate([
        pure_1.PURE
    ], CheckboxPage);
    return CheckboxPage;
}(react_1.default.Component));
react_2.storiesOf('Checkbox', module)
    .add('default', function () {
    return react_1.default.createElement(CheckboxPage, { isDisabled: addon_knobs_1.boolean('isDisabled', false) });
})
    .add('disabled', function () { return react_1.default.createElement(CheckboxPage, { isDisabled: true }); });
//# sourceMappingURL=Checkbox.page.js.map