"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var pure_1 = require("../../utils/pure");
var react_2 = require("react");
var Popover_1 = require("../Popover/Popover");
var withTheme_1 = require("../../utils/withTheme");
var with_defaults_1 = require("../../utils/with-defaults");
exports.DROPDOWN = Symbol('Dropdown');
var RawDropdown = /** @class */ (function (_super) {
    tslib_1.__extends(RawDropdown, _super);
    function RawDropdown() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.innerRef = function (ref) {
            _this.anchorRef = ref;
        };
        _this.onAnchorClick = function () {
            _this.props.onToggle(!_this.props.isOpened);
        };
        _this.onPopoverRequestClose = function () {
            _this.props.onToggle(false);
        };
        return _this;
    }
    RawDropdown.prototype.render = function () {
        var _a = this.props, Anchor = _a.Anchor, Popover = _a.Popover, children = _a.children, theme = _a.theme, hasArrow = _a.hasArrow, isOpened = _a.isOpened;
        return (react_1.default.createElement(Anchor, { onClick: this.onAnchorClick, innerRef: this.innerRef },
            react_1.default.createElement(Popover, { isOpened: isOpened, hasArrow: hasArrow, theme: theme.Popover, onRequestClose: this.onPopoverRequestClose, anchor: this.anchorRef, closeOnClickAway: true }, children)));
    };
    RawDropdown = tslib_1.__decorate([
        pure_1.PURE
    ], RawDropdown);
    return RawDropdown;
}(react_2.Component));
exports.Dropdown = withTheme_1.withTheme(exports.DROPDOWN)(with_defaults_1.withDefaults({
    Popover: Popover_1.Popover,
})(RawDropdown));
//# sourceMappingURL=Dropdown.js.map