"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_2 = require("@storybook/react");
var Demo_1 = tslib_1.__importDefault(require("../demo/Demo"));
var pure_1 = require("../../utils/pure");
var Grid_1 = require("./Grid");
var Grid_demo_styl_1 = tslib_1.__importDefault(require("./Grid.demo.styl"));
var gridTheme = {
    container: Grid_demo_styl_1.default.container,
    gridBody: Grid_demo_styl_1.default.gridBody,
    gridHead: Grid_demo_styl_1.default.gridHead,
    gridHead_paddedForScrollbar: Grid_demo_styl_1.default.gridHead_paddedForScrollbar,
    gridCell__placeholder: Grid_demo_styl_1.default.gridCell__placeholder,
    gridCell__content: Grid_demo_styl_1.default.gridCell__content,
    gridCell__content_left: Grid_demo_styl_1.default.gridCell__content_left,
    gridCell__content_center: Grid_demo_styl_1.default.gridCell__content_center,
    gridCell__content_right: Grid_demo_styl_1.default.gridCell__content_right,
    horizontal_scrollbar__bar: Grid_demo_styl_1.default.horizontal_scrollbar__bar,
    vertical_scrollbar__bar: Grid_demo_styl_1.default.vertical_scrollbar__bar,
};
var GridPage = /** @class */ (function (_super) {
    tslib_1.__extends(GridPage, _super);
    function GridPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isLong: true,
            counter: 0,
        };
        return _this;
    }
    GridPage.prototype.componentDidMount = function () {
        // this._interval1 = setInterval(() => {
        // 	this.setState({
        // 		isLong: !this.state.isLong
        // 	});
        // }, 3000);
        var _this = this;
        this._interval2 = setInterval(function () {
            _this.setState({
                counter: _this.state.counter + 1,
            });
        }, 1000);
    };
    GridPage.prototype.componentWillUnmount = function () {
        clearTimeout(this._interval1);
        clearInterval(this._interval2);
    };
    GridPage.prototype.render = function () {
        var _this = this;
        return (react_1.default.createElement(Demo_1.default, null,
            react_1.default.createElement(Grid_1.Grid, { theme: gridTheme },
                react_1.default.createElement(Grid_1.GridHead, { theme: gridTheme },
                    react_1.default.createElement(Grid_1.GridRow, null,
                        react_1.default.createElement(Grid_1.GridCell, { align: Grid_1.GridCellAlignment.LEFT, theme: gridTheme }, "1"),
                        react_1.default.createElement(Grid_1.GridCell, { theme: gridTheme }, this.state.isLong ? '2_______________________________________' : '2'),
                        react_1.default.createElement(Grid_1.GridCell, { theme: gridTheme }, "3"))),
                react_1.default.createElement(Grid_1.GridBody, { theme: gridTheme }, Array.from(new Array(20), function () { return 0; }).map(function (_, i) { return (react_1.default.createElement(Grid_1.GridRow, { key: i },
                    react_1.default.createElement(Grid_1.GridCell, { align: Grid_1.GridCellAlignment.LEFT, theme: gridTheme }, _this.state.counter),
                    react_1.default.createElement(Grid_1.GridCell, { theme: gridTheme }, "2"),
                    react_1.default.createElement(Grid_1.GridCell, { theme: gridTheme }, "3_______________________________________"))); })))));
    };
    GridPage = tslib_1.__decorate([
        pure_1.PURE
    ], GridPage);
    return GridPage;
}(react_1.default.Component));
react_2.storiesOf('Grid', module).add('default', function () { return react_1.default.createElement(GridPage, null); });
//# sourceMappingURL=Grid.page.js.map