"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var withTheme_1 = require("../../utils/withTheme");
var LoadingIndicator_1 = require("../LoadingIndicator/LoadingIndicator");
var pure_1 = require("../../utils/pure");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var with_defaults_1 = require("../../utils/with-defaults");
exports.LOADING_INDICATION = Symbol('LoadingIndicaton');
var RawLoadingIndicaton = /** @class */ (function (_super) {
    tslib_1.__extends(RawLoadingIndicaton, _super);
    function RawLoadingIndicaton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isDisplay: true,
        };
        _this.setDisplayNone = function () {
            _this.setState({
                isDisplay: false,
            });
        };
        return _this;
    }
    RawLoadingIndicaton.prototype.render = function () {
        var _a;
        var _b = this.props, theme = _b.theme, isVisible = _b.isVisible, LoadingIndicator = _b.LoadingIndicator;
        var isDisplay = this.state.isDisplay;
        var className = classnames_1.default(theme.container, (_a = {},
            _a[theme.container_isVisible] = isVisible,
            _a[theme.container_isNotDisplay] = !isDisplay,
            _a));
        return (react_1.default.createElement("div", { className: className },
            react_1.default.createElement(LoadingIndicator, { theme: theme.LoadingIndicator })));
    };
    RawLoadingIndicaton.prototype.componentDidMount = function () {
        var _a = this.props, isVisible = _a.isVisible, hideTimer = _a.hideTimer;
        if (hideTimer) {
            this.timeoutWorker(hideTimer, isVisible);
        }
    };
    RawLoadingIndicaton.prototype.componentWillUnmount = function () {
        clearTimeout(this.timer);
    };
    RawLoadingIndicaton.prototype.timeoutWorker = function (hideTimer, isVisible) {
        if (!isVisible) {
            this.timer = window.setTimeout(this.setDisplayNone, hideTimer);
        }
        else {
            clearTimeout(this.timer);
            this.setState({
                isDisplay: true,
            });
        }
    };
    RawLoadingIndicaton.prototype.componentWillReceiveProps = function (nextProps) {
        var isVisible = nextProps.isVisible, hideTimer = nextProps.hideTimer;
        if (hideTimer) {
            this.timeoutWorker(hideTimer, isVisible);
        }
    };
    RawLoadingIndicaton = tslib_1.__decorate([
        pure_1.PURE
    ], RawLoadingIndicaton);
    return RawLoadingIndicaton;
}(react_1.default.Component));
exports.LoadingIndication = withTheme_1.withTheme(exports.LOADING_INDICATION)(with_defaults_1.withDefaults({
    LoadingIndicator: LoadingIndicator_1.LoadingIndicator,
})(RawLoadingIndicaton));
//# sourceMappingURL=LoadingIndication.js.map