"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var Demo_1 = tslib_1.__importDefault(require("../../demo/Demo"));
var Button_1 = require("../../Button/Button");
var Popover_1 = require("../Popover");
var Popover_model_1 = require("../Popover.model");
var Selectbox_1 = require("../../Selectbox/Selectbox");
var Menu_1 = require("../../Menu/Menu");
var pure_1 = require("../../../utils/pure");
var react_2 = require("@storybook/react");
var Control_1 = require("../../Control/Control");
var Popover_page_styl_1 = tslib_1.__importDefault(require("./theme/Popover.page.styl"));
var Scrollable_1 = require("../../Scrollable/Scrollable");
var InputWithPopover_page_1 = require("./InputWithPopover.page");
var FixedPopover_page_1 = require("./FixedPopover.page");
var buttonTheme = {
    container: Popover_page_styl_1.default.toggleButton,
};
var HeavyContent = /** @class */ (function (_super) {
    tslib_1.__extends(HeavyContent, _super);
    function HeavyContent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HeavyContent.prototype.render = function () {
        return (react_1.default.createElement("div", null,
            react_1.default.createElement(Scrollable_1.Scrollable, null,
                react_1.default.createElement("div", { className: Popover_page_styl_1.default.heavy },
                    react_1.default.createElement("h2", null, "Tethered Content"),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title."),
                    react_1.default.createElement("p", null, "A paragraph to accompany the title.")))));
    };
    HeavyContent = tslib_1.__decorate([
        pure_1.PURE
    ], HeavyContent);
    return HeavyContent;
}(react_1.default.Component));
var Stateful = Control_1.stateful()(Selectbox_1.Selectbox);
var StatefulOpened = Control_1.stateful('isOpened', 'onToggle', 'defaultIsOpened')(Stateful);
var PopoverPage = /** @class */ (function (_super) {
    tslib_1.__extends(PopoverPage, _super);
    function PopoverPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            placement: Popover_model_1.PopoverPlacement.Bottom,
            align: Popover_model_1.PopoverAlign.Left,
            isOpened: false,
            isLongText: false,
            closeOnClickAway: false,
        };
        _this.onPlacementSelect = function (placement) {
            var placementWasVertical = [Popover_model_1.PopoverPlacement.Top, Popover_model_1.PopoverPlacement.Bottom].includes(_this.state.placement);
            var placementWillBeVertical = [Popover_model_1.PopoverPlacement.Top, Popover_model_1.PopoverPlacement.Bottom].includes(placement);
            if (placementWasVertical && !placementWillBeVertical) {
                //placement orientation changed from vertical to horizontal
                //choose default vertical align
                _this.setState({
                    align: Popover_model_1.PopoverAlign.Top,
                });
            }
            else if (!placementWasVertical && placementWillBeVertical) {
                //placement orientation changed from horizontal to vertical
                //choose default horizontal align
                _this.setState({
                    align: Popover_model_1.PopoverAlign.Left,
                });
            }
            //finally set placement
            _this.setState({
                placement: placement,
            });
        };
        _this.onAlignSelect = function (align) {
            _this.setState({
                align: align,
            });
        };
        _this.onToggleClick = function () {
            _this.setState({
                isOpened: !_this.state.isOpened,
            });
        };
        _this.onPopoverRequestClose = function () {
            _this.setState({
                isOpened: false,
            });
        };
        _this.onCloseOnClickAwayChange = function () {
            _this.setState({
                closeOnClickAway: !_this.state.closeOnClickAway,
            });
        };
        return _this;
    }
    PopoverPage.prototype.render = function () {
        var _this = this;
        var _a = this.state, placement = _a.placement, align = _a.align, isOpened = _a.isOpened, closeOnClickAway = _a.closeOnClickAway;
        return (react_1.default.createElement(Demo_1.default, null,
            react_1.default.createElement("div", { className: Popover_page_styl_1.default.container },
                react_1.default.createElement("div", null,
                    react_1.default.createElement("label", { className: Popover_page_styl_1.default.label }, "Placement"),
                    react_1.default.createElement(StatefulOpened, { defaultIsOpened: false, defaultValue: Popover_model_1.PopoverPlacement.Bottom, onValueChange: this.onPlacementSelect },
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverPlacement.Top }, "Top"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverPlacement.Bottom }, "Bottom"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverPlacement.Left }, "Left"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverPlacement.Right }, "Right")),
                    react_1.default.createElement("label", { className: Popover_page_styl_1.default.label }, "Align"),
                    (placement === Popover_model_1.PopoverPlacement.Top || placement === Popover_model_1.PopoverPlacement.Bottom) && (react_1.default.createElement(StatefulOpened, { defaultIsOpened: false, defaultValue: Popover_model_1.PopoverAlign.Left, onValueChange: this.onAlignSelect },
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Left }, "Left"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Center }, "Center"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Right }, "Right"))),
                    (placement === Popover_model_1.PopoverPlacement.Left || placement === Popover_model_1.PopoverPlacement.Right) && (react_1.default.createElement(StatefulOpened, { defaultIsOpened: false, defaultValue: Popover_model_1.PopoverAlign.Top, onValueChange: this.onAlignSelect },
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Top }, "Top"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Middle }, "Middle"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Bottom }, "Bottom"))),
                    react_1.default.createElement("label", { className: Popover_page_styl_1.default.label },
                        "Close on clickaway",
                        ' ',
                        react_1.default.createElement("input", { type: "checkbox", value: closeOnClickAway.toString(), onChange: this.onCloseOnClickAwayChange }))),
                react_1.default.createElement(Button_1.Button, { isPrimary: true, onClick: this.onToggleClick, ref: function (el) { return (_this._anchor = el); }, theme: buttonTheme },
                    isOpened ? 'Hide' : 'Open',
                    react_1.default.createElement(Popover_1.Popover, { placement: placement, isOpened: isOpened, onRequestClose: this.onPopoverRequestClose, closeOnClickAway: closeOnClickAway, hasArrow: true, align: align, anchor: this._anchor },
                        react_1.default.createElement(HeavyContent, null))))));
    };
    PopoverPage = tslib_1.__decorate([
        pure_1.PURE
    ], PopoverPage);
    return PopoverPage;
}(react_1.default.Component));
react_2.storiesOf('Popover', module)
    .add('default', function () { return react_1.default.createElement(PopoverPage, null); })
    .add('input with popover', function () { return react_1.default.createElement(InputWithPopover_page_1.InputWithPopoverPage, null); })
    .add('fixed popover', function () { return react_1.default.createElement(FixedPopover_page_1.FixedPopoverPage, null); });
//# sourceMappingURL=Popover.page.js.map