"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var pure_1 = require("../../utils/pure");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var react_2 = require("react");
var PopupUI = /** @class */ (function (_super) {
    tslib_1.__extends(PopupUI, _super);
    function PopupUI() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getRef = function (backdrop) {
            var innerRef = _this.props.innerRef;
            if (innerRef) {
                innerRef(backdrop);
            }
        };
        _this.handleBackdropClick = function (e) {
            e.stopPropagation();
            _this.props.onBackdropClick(e);
        };
        return _this;
    }
    PopupUI.prototype.render = function () {
        var _a;
        var _b = this.props, theme = _b.theme, header = _b.header, children = _b.children, footer = _b.footer, isModal = _b.isModal, shouldCloseOnClickAway = _b.shouldCloseOnClickAway;
        var backdropClassName = classnames_1.default(theme.backdrop, (_a = {},
            _a[theme.backdrop_isModal] = isModal,
            _a[theme.backdrop_closeOnClickAway] = shouldCloseOnClickAway,
            _a));
        return (react_1.default.createElement("div", { className: backdropClassName, ref: this.getRef, onClick: this.handleBackdropClick },
            react_1.default.createElement("div", { className: theme.container },
                header && react_1.default.createElement("div", { className: theme.header }, header),
                react_1.default.createElement("div", { className: theme.body }, children),
                footer && react_1.default.createElement("div", { className: theme.footer }, footer))));
    };
    PopupUI = tslib_1.__decorate([
        pure_1.PURE
    ], PopupUI);
    return PopupUI;
}(react_2.Component));
exports.PopupUI = PopupUI;
//# sourceMappingURL=popup-ui.component.js.map