"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var pure_1 = require("../../utils/pure");
var withTheme_1 = require("../../utils/withTheme");
var element_resize_detector_1 = tslib_1.__importDefault(require("element-resize-detector"));
var raf_1 = require("@devexperts/utils/dist/function/raf");
exports.NativeResizeDetector = element_resize_detector_1.default({
    strategy: 'scroll',
});
exports.RESIZE_DETECTOR = Symbol('ResizeDetector');
var RawResizeDetector = /** @class */ (function (_super) {
    tslib_1.__extends(RawResizeDetector, _super);
    function RawResizeDetector() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onResize = raf_1.raf(function (element) {
            _this.props.onResize(element);
        });
        return _this;
    }
    RawResizeDetector.prototype.componentDidMount = function () {
        if (this.element) {
            exports.NativeResizeDetector.listenTo(this.element, this.onResize);
        }
    };
    RawResizeDetector.prototype.componentWillUnmount = function () {
        if (this.element) {
            exports.NativeResizeDetector.uninstall(this.element);
        }
    };
    RawResizeDetector.prototype.render = function () {
        var _this = this;
        var theme = this.props.theme;
        return react_1.default.createElement("div", { className: theme.container, ref: function (el) { return (_this.element = el); } });
    };
    RawResizeDetector = tslib_1.__decorate([
        pure_1.PURE
    ], RawResizeDetector);
    return RawResizeDetector;
}(react_1.default.Component));
exports.ResizeDetector = withTheme_1.withTheme(exports.RESIZE_DETECTOR)(RawResizeDetector);
//# sourceMappingURL=ResizeDetector.js.map