import React from 'react';
import { Scrollbar, TScrollbarProps } from './Scrollbar';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare const HORIZONTAL_SCROLLBAR: symbol;
export declare type TAdditionalHorizontalProps = {
    scrollLeft?: number;
};
export declare type TFullHorizontalProps = TScrollbarProps & TAdditionalHorizontalProps;
export declare class RawHorizontalScrollbar extends Scrollbar<TAdditionalHorizontalProps> {
    _ratio: {
        size: number;
        position: number;
    };
    _previousDragCoordinate: number;
    _minBarSize: number;
    /**
     * @returns {Number}
     * @protected
     */
    _getMinBarSize(): number;
    /**
     * Hide native scroll
     * @private
     */
    _hideNativeScrollContainer(): void;
    componentDidMount(): void;
    componentWillReceiveProps(newProps: TFullHorizontalProps): void;
    _update(): void;
    _toggle(): void;
    _updateBar(): void;
    _getRatio(): {
        size: number;
        position: number;
    };
    _scrollTo: (position: number) => void;
    /**
     * @param {WheelEvent} event
     * @protected
     */
    onTrackMouseWheel: (event: React.MouseEvent<HTMLDivElement, MouseEvent> & {
        deltaX: number;
    }) => void;
    /**
     * @param {MouseEvent} event
     * @protected
     */
    onTrackClick: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    /**
     * @param {MouseEvent} event
     * @protected
     */
    onBarDragStart: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    /**
     * @param {MouseEvent} event
     * @protected
     */
    onBarDrag: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
}
export declare type THorizontalScrollbarProps = PartialKeys<TFullHorizontalProps, 'theme'>;
export declare const HorizontalScrollbar: React.ComponentClass<THorizontalScrollbarProps>;
