"use strict";
/**
 * @typedef {Object} TScrollbarSize
 * @property {Number} width
 * @property {Number} height
 */
Object.defineProperty(exports, "__esModule", { value: true });
var scrollbarSize;
/**
 * size
 * @param {String} scrollbarContainerClassName
 * @returns {*}
 */
function getScrollbarSize(scrollbarContainerClassName) {
    if (!scrollbarSize) {
        var dummy = document.createElement('div');
        dummy.className = scrollbarContainerClassName;
        dummy.style.width = '100px';
        dummy.style.height = '100px';
        dummy.style.position = 'absolute';
        dummy.style.top = '-200%';
        dummy.style.left = '-200%';
        dummy.style.overflow = 'scroll';
        dummy.style.opacity = '0';
        document.body.appendChild(dummy);
        scrollbarSize = {
            width: dummy.offsetWidth - dummy.clientWidth,
            height: dummy.offsetHeight - dummy.clientHeight,
        };
        document.body.removeChild(dummy);
    }
    return scrollbarSize;
}
exports.default = getScrollbarSize;
//# sourceMappingURL=Scrollbar.util.js.map