"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_2 = require("react");
var pure_1 = require("../../utils/pure");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var withTheme_1 = require("../../utils/withTheme");
exports.TOGGLE_BUTTONS = Symbol('ToggleButtons');
var RawToggleButtons = /** @class */ (function (_super) {
    tslib_1.__extends(RawToggleButtons, _super);
    function RawToggleButtons() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            toggleIndex: 0,
        };
        _this.renderToggleItem = function (child, i) {
            var _a;
            if (!react_1.default.isValidElement(child)) {
                return child;
            }
            var _b = _this.props, theme = _b.theme, isVertical = _b.isVertical, isDisabled = _b.isDisabled;
            var isActive = i === _this.state.toggleIndex;
            var toggleButtonTheme = withTheme_1.mergeThemes({
                container: classnames_1.default(theme.container__item, (_a = {},
                    _a[theme.container__item_active] = isActive,
                    _a[theme.container__vertical] = isVertical,
                    _a)),
            }, child.props.theme || {});
            var childProps = Object.assign({}, child.props, {
                isActive: isActive,
                isDisabled: isDisabled,
                onClick: _this.onToggleSelect(i, child.props.onClick),
                theme: toggleButtonTheme,
            });
            return react_1.default.cloneElement(child, childProps);
        };
        _this.onToggleSelect = function (toggleIndex, childClickHandler) { return function () {
            if (typeof _this.props.toggleIndex === 'undefined') {
                _this.setState({
                    toggleIndex: toggleIndex,
                });
            }
            childClickHandler && childClickHandler();
            _this.props.onChange && _this.props.onChange(toggleIndex);
        }; };
        return _this;
    }
    RawToggleButtons.prototype.componentWillMount = function () {
        var _a = this.props, toggleIndex = _a.toggleIndex, defaultIndex = _a.defaultIndex;
        this.setState({
            toggleIndex: typeof toggleIndex !== 'undefined' ? toggleIndex : defaultIndex || 0,
        });
    };
    RawToggleButtons.prototype.componentWillReceiveProps = function (newProps) {
        if (typeof newProps.toggleIndex !== 'undefined') {
            this.setState({
                toggleIndex: newProps.toggleIndex,
            });
        }
    };
    RawToggleButtons.prototype.render = function () {
        var _a = this.props, children = _a.children, theme = _a.theme;
        return react_1.default.createElement("div", { className: theme.container__wrapper }, react_1.default.Children.map(children, this.renderToggleItem));
    };
    RawToggleButtons = tslib_1.__decorate([
        pure_1.PURE
    ], RawToggleButtons);
    return RawToggleButtons;
}(react_2.Component));
exports.ToggleButtons = withTheme_1.withTheme(exports.TOGGLE_BUTTONS)(RawToggleButtons);
//# sourceMappingURL=ToggleButtons.js.map