"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_dom_1 = tslib_1.__importDefault(require("react-dom"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var pure_1 = require("../../utils/pure");
var withTheme_1 = require("../../utils/withTheme");
exports.INPUT = Symbol('Input');
var RawInput = /** @class */ (function (_super) {
    tslib_1.__extends(RawInput, _super);
    function RawInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isFocused: false,
        };
        _this.getRef = function (input) {
            var innerRef = _this.props.innerRef;
            if (innerRef) {
                innerRef(input);
            }
        };
        _this.onFocus = function (e) {
            if (!_this.props.isDisabled && !_this.state.isFocused && !_this.isFocusingOnInput && _this.input) {
                var input = react_dom_1.default.findDOMNode(_this.input);
                if (input) {
                    _this.isFocusingOnInput = true;
                    input.focus();
                    _this.isFocusingOnInput = false;
                }
                _this.setState({
                    isFocused: true,
                });
                _this.props.onFocus && _this.props.onFocus(e);
            }
        };
        _this.onBlur = function (e) {
            if (!_this.props.isDisabled && _this.state.isFocused && !_this.isFocusingOnInput) {
                _this.setState({
                    isFocused: false,
                });
                _this.props.onBlur && _this.props.onBlur(e);
            }
        };
        _this.onChange = function (e) {
            _this.props.onValueChange && _this.props.onValueChange(e.target.value);
            _this.props.onChange && _this.props.onChange(e);
        };
        return _this;
    }
    RawInput.prototype.render = function () {
        var _a;
        var _this = this;
        var _b = this.props, theme = _b.theme, isDisabled = _b.isDisabled, isReadOnly = _b.isReadOnly, tabIndex = _b.tabIndex, children = _b.children, value = _b.value, error = _b.error, onClick = _b.onClick, onMouseDown = _b.onMouseDown, onMouseUp = _b.onMouseUp, onMouseEnter = _b.onMouseEnter, onMouseLeave = _b.onMouseLeave, onKeyDown = _b.onKeyDown, onKeyUp = _b.onKeyUp, onKeyPress = _b.onKeyPress, min = _b.min, placeholder = _b.placeholder, max = _b.max, type = _b.type, name = _b.name, pattern = _b.pattern, id = _b.id, onWheel = _b.onWheel;
        var isFocused = this.state.isFocused;
        var className = classnames_1.default(theme.container, (_a = {},
            _a[theme.container_isFocused] = !isDisabled && isFocused,
            _a[theme.container_isDisabled] = isDisabled,
            _a[theme.container_isReadOnly] = isReadOnly,
            _a[theme.container_hasError] = Boolean(error),
            _a));
        var isCustom = type === 'hidden';
        var keyboardEvents = {
            onKeyDown: onKeyDown,
            onKeyUp: onKeyUp,
            onKeyPress: onKeyPress,
        };
        return (react_1.default.createElement("div", tslib_1.__assign({ className: className, id: id, onClick: function (e) { return !isDisabled && onClick && onClick(e); }, onMouseDown: onMouseDown, onMouseUp: onMouseUp, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave, onFocus: this.onFocus, onBlur: this.onBlur, onWheel: onWheel, tabIndex: !isCustom && (isFocused || isDisabled) ? -1 : tabIndex, ref: this.getRef }, (isCustom && keyboardEvents)),
            react_1.default.createElement("input", tslib_1.__assign({ className: theme.input, ref: function (el) { return (_this.input = el); }, value: value, type: type, min: min, max: max, pattern: pattern, name: name, onChange: this.onChange, placeholder: placeholder, tabIndex: -1, readOnly: isReadOnly, disabled: isDisabled }, (!isCustom && keyboardEvents))),
            children));
    };
    RawInput.defaultProps = {
        tabIndex: 0,
    };
    RawInput = tslib_1.__decorate([
        pure_1.PURE
    ], RawInput);
    return RawInput;
}(react_1.default.Component));
exports.Input = withTheme_1.withTheme(exports.INPUT)(RawInput);
//# sourceMappingURL=Input.js.map