"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var function_1 = require("fp-ts/lib/function");
function useObservable(M) {
    return function (fa, initial) {
        var _a = react_1.useState(initial), state = _a[0], setState = _a[1];
        react_1.useEffect(function () {
            var subscription = M.subscribe(fa, {
                next: setState,
                end: function_1.constVoid,
            });
            return function () { return subscription.unsubscribe(); };
        }, [fa, setState]);
        return state;
    };
}
exports.useObservable = useObservable;
//# sourceMappingURL=use-observable.js.map