"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var function_1 = require("fp-ts/lib/function");
var Array_1 = require("fp-ts/lib/Array");
// eslint-disable-next-line @typescript-eslint/no-require-imports, @typescript-eslint/no-var-requires
var hoistNonReactStatics = require('hoist-non-react-statics'); // tslint:disable-line no-require-imports no-var-requires
var voidObserver = {
    next: function_1.constVoid,
    end: function_1.constVoid,
};
function withObservable(M) {
    return function (Target) { return function (selector) {
        var WithObservable = /** @class */ (function (_super) {
            tslib_1.__extends(WithObservable, _super);
            function WithObservable() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.adapter = M.createAdapter();
                _this.selected = selector(_this.adapter[1]);
                _this.setStateObserver = {
                    next: _this.setState.bind(_this),
                    end: function_1.constVoid,
                };
                return _this;
            }
            WithObservable.prototype.componentDidMount = function () {
                var _a = this.selected, props = _a.props, effects$ = _a.effects$;
                if (props) {
                    var inputs = Object.keys(props).map(function (key) {
                        return M.map(props[key], function (value) {
                            var _a;
                            return (_a = {}, _a[key] = value, _a);
                        });
                    });
                    var merged = Array_1.array.reduce(inputs, M.zero(), function (b, a) { return M.alt(b, function () { return a; }); });
                    this.inputSubscription = M.subscribe(merged, this.setStateObserver);
                }
                if (effects$) {
                    this.effectsSubscription = M.subscribe(effects$, voidObserver);
                }
            };
            WithObservable.prototype.componentWillReceiveProps = function (nextProps, nextContext) {
                this.adapter[0](nextProps);
            };
            WithObservable.prototype.componentWillMount = function () {
                this.inputSubscription && this.inputSubscription.unsubscribe();
                this.effectsSubscription && this.effectsSubscription.unsubscribe();
            };
            WithObservable.prototype.render = function () {
                return react_1.createElement(Target, Object.assign({}, this.selected.defaultProps, this.props, this.state || {}));
            };
            WithObservable.displayName = "WithObservable(" + (Target.displayName || Target.name) + ")";
            return WithObservable;
        }(react_1.PureComponent));
        hoistNonReactStatics(WithObservable, Target);
        return WithObservable; //defaultProps are tracked by defaultProps argument;
    }; };
}
exports.withObservable = withObservable;
//# sourceMappingURL=with-observable.js.map