import { ComponentClass, ComponentType } from 'react';
import { Observable, SchedulerLike } from 'rxjs';
export declare type Observify<P extends object> = {
    readonly [K in keyof P]: Observable<P[K]>;
};
export declare type WithRXSelectorResult<P extends object, D extends Partial<P>> = {
    props?: Partial<Observify<P>>;
    defaultProps?: D;
    effects$?: Observable<unknown>;
};
export declare type WithRXOptions = {
    scheduler?: SchedulerLike;
};
/**
 * curried for better type inference
 * @see https://github.com/Microsoft/TypeScript/issues/15005#issuecomment-430588884
 */
export declare const withRX: <P extends object>(Target: ComponentType<P>) => <D extends Partial<P>>(selector: (props$: Observable<Readonly<P>>) => WithRXSelectorResult<P, D>, options?: WithRXOptions) => ComponentClass<Pick<P, Exclude<keyof P, keyof D>> & Partial<D>, any>;
